#include "TFT128160.h"
#include "tft_font.h"


//------------------------------------------------------------





//------------------------------------------------------------




void TFT_Write_8bit(u8 dat, u8 cmd)
{
    TFT18_CS = 0;
    if (cmd)
        TFT18_DC = 1;   // д
    else
        TFT18_DC = 0;   // дָ
    #if SPI_MODE == 0       // 0ģSPI
    SPI_WirteByte_Soft(dat);
    #elif SPI_MODE ==1      // 1ӲSPI
    SPI_WriteByte_Hard(dat);
    #endif
    TFT18_CS = 1;
}

void TFT_Write_16bit(u16 dat)
{
    TFT18_CS = 0;
    TFT18_DC = 1;   // д
    #if SPI_MODE == 0       // 0ģSPI
    SPI_WirteByte_Soft((u8)(dat >> 8));   //д8λ
    SPI_WirteByte_Soft((u8)dat);        //д8λ
#elif SPI_MODE ==1      // 1ӲSPI
    SPI_WriteByte_Hard((u8)(dat >> 8));   //д8λ
    SPI_WriteByte_Hard((u8)dat);        //д8λ
    #endif
    TFT18_CS = 1;
}

/**
 * @name TFT_Windows_Set
 * @brief ʼͽַ
 * @param x1,x2 еʼͽַ
 * @param y1,y2 еʼͽַ
 * @return 
 * @version 汾v1.0
 * @date ڣ2024-5-13
 * @author ߣ
 * @note עͣ
 */
void TFT_Windows_Set(u16 x1,u16 y1,u16 x2,u16 y2)
{
    TFT_Write_8bit(0x2a,TFT_CMD);//еַ
    TFT_Write_16bit(x1);
    TFT_Write_16bit(x2);
    TFT_Write_8bit(0x2b,TFT_CMD);//еַ
    TFT_Write_16bit(y1);
    TFT_Write_16bit(y2);
    TFT_Write_8bit(0x2c,TFT_CMD);//д

    // if(USE_HORIZONTAL==0)
	// {
	// 	TFT_Write_8bit(0x2a,TFT_CMD);//еַ
	// 	TFT_Write_16bit(x1+2);
	// 	TFT_Write_16bit(x2+2);
	// 	TFT_Write_8bit(0x2b,TFT_CMD);//еַ
	// 	TFT_Write_16bit(y1+1);
	// 	TFT_Write_16bit(y2+1);
	// 	TFT_Write_8bit(0x2c,TFT_CMD);//д
	// }
	// else if(USE_HORIZONTAL==1)
	// {
	// 	TFT_Write_8bit(0x2a,TFT_CMD);//еַ
	// 	TFT_Write_16bit(x1+2);
	// 	TFT_Write_16bit(x2+2);
	// 	TFT_Write_8bit(0x2b,TFT_CMD);//еַ
	// 	TFT_Write_16bit(y1+1);
	// 	TFT_Write_16bit(y2+1);
	// 	TFT_Write_8bit(0x2c,TFT_CMD);//д
	// }
	// else if(USE_HORIZONTAL==2)
	// {
	// 	TFT_Write_8bit(0x2a,TFT_CMD);//еַ
	// 	TFT_Write_16bit(x1+1);
	// 	TFT_Write_16bit(x2+1);
	// 	TFT_Write_8bit(0x2b,TFT_CMD);//еַ
	// 	TFT_Write_16bit(y1+2);
	// 	TFT_Write_16bit(y2+2);
	// 	TFT_Write_8bit(0x2c,TFT_CMD);//д
	// }
	// else
	// {
	// 	TFT_Write_8bit(0x2a,TFT_CMD);//еַ
	// 	TFT_Write_16bit(x1+1);
	// 	TFT_Write_16bit(x2+1);
	// 	TFT_Write_8bit(0x2b,TFT_CMD);//еַ
	// 	TFT_Write_16bit(y1+2);
	// 	TFT_Write_16bit(y2+2);
	// 	TFT_Write_8bit(0x2c,TFT_CMD);//д
	// }
}

void TFT_Set_Cursor(u16 x0, u16 y0)
{
    TFT_Windows_Set(x0, y0, x0, y0);
}

void TFT_Init()
{
    TFT18_RES = 0;//λ
    delay_ms(100);
	TFT18_RES = 1;
	delay_ms(100);
	
	TFT18_BLK = 1;//򿪱
    delay_ms(100);
	
	//************* Start Initial Sequence **********//
	TFT_Write_8bit(0x11,TFT_CMD);       //Sleep out 
	delay_ms(120);
	//------------------------------------ST7735S Frame Rate-----------------------------------------// 
	TFT_Write_8bit(0xB1,TFT_CMD);       // дָ
	TFT_Write_8bit(0x05,TFT_DATA); 
	TFT_Write_8bit(0x3C,TFT_DATA); 
	TFT_Write_8bit(0x3C,TFT_DATA); 
	TFT_Write_8bit(0xB2,TFT_CMD);       // дָ
	TFT_Write_8bit(0x05,TFT_DATA);
	TFT_Write_8bit(0x3C,TFT_DATA); 
	TFT_Write_8bit(0x3C,TFT_DATA); 
	TFT_Write_8bit(0xB3,TFT_CMD);       // дָ
	TFT_Write_8bit(0x05,TFT_DATA); 
	TFT_Write_8bit(0x3C,TFT_DATA); 
	TFT_Write_8bit(0x3C,TFT_DATA); 
	TFT_Write_8bit(0x05,TFT_DATA); 
	TFT_Write_8bit(0x3C,TFT_DATA); 
	TFT_Write_8bit(0x3C,TFT_DATA); 
	//------------------------------------End ST7735S Frame Rate---------------------------------// 
	TFT_Write_8bit(0xB4,TFT_CMD); //Dot inversion 
	TFT_Write_8bit(0x03,TFT_DATA); 
	//------------------------------------ST7735S Power Sequence---------------------------------// 
	TFT_Write_8bit(0xC0,TFT_CMD);       // дָ
	TFT_Write_8bit(0x28,TFT_DATA); 
	TFT_Write_8bit(0x08,TFT_DATA); 
	TFT_Write_8bit(0x04,TFT_DATA); 
	TFT_Write_8bit(0xC1,TFT_CMD);       // дָ
	TFT_Write_8bit(0XC0,TFT_DATA); 
	TFT_Write_8bit(0xC2,TFT_CMD);       // дָ
	TFT_Write_8bit(0x0D,TFT_DATA); 
	TFT_Write_8bit(0x00,TFT_DATA); 
	TFT_Write_8bit(0xC3,TFT_CMD);       // дָ
	TFT_Write_8bit(0x8D,TFT_DATA); 
	TFT_Write_8bit(0x2A,TFT_DATA); 
	TFT_Write_8bit(0xC4,TFT_CMD);       // дָ
	TFT_Write_8bit(0x8D,TFT_DATA); 
	TFT_Write_8bit(0xEE,TFT_DATA); 
	//---------------------------------End ST7735S Power Sequence-------------------------------------// 
	TFT_Write_8bit(0xC5,TFT_CMD); //VCOM 
	TFT_Write_8bit(0x1A,TFT_DATA);
    TFT_Write_8bit(0xC6,TFT_CMD);   // ˢ
    TFT_Write_8bit(0x0f,TFT_DATA);  // 0x1f,39Hz 0x0f,60Hz 0x00,119Hz
	TFT_Write_8bit(0x36,TFT_CMD);   // MX, MY, RGB mode 
	if(USE_HORIZONTAL==0)TFT_Write_8bit(0x00,TFT_DATA);
	else if(USE_HORIZONTAL==1)TFT_Write_8bit(0x60,TFT_DATA);
	else if(USE_HORIZONTAL==2)TFT_Write_8bit(0xC0,TFT_DATA);
	else TFT_Write_8bit(0xA0,TFT_DATA); 
	//------------------------------------ST7735S Gamma Sequence---------------------------------// 
	TFT_Write_8bit(0xE0,TFT_CMD);       // дָ,
	TFT_Write_8bit(0x04,TFT_DATA); 
	TFT_Write_8bit(0x22,TFT_DATA); 
	TFT_Write_8bit(0x07,TFT_DATA); 
	TFT_Write_8bit(0x0A,TFT_DATA); 
	TFT_Write_8bit(0x2E,TFT_DATA); 
	TFT_Write_8bit(0x30,TFT_DATA); 
	TFT_Write_8bit(0x25,TFT_DATA); 
	TFT_Write_8bit(0x2A,TFT_DATA); 
	TFT_Write_8bit(0x28,TFT_DATA); 
	TFT_Write_8bit(0x26,TFT_DATA); 
	TFT_Write_8bit(0x2E,TFT_DATA); 
	TFT_Write_8bit(0x3A,TFT_DATA); 
	TFT_Write_8bit(0x00,TFT_DATA); 
	TFT_Write_8bit(0x01,TFT_DATA); 
	TFT_Write_8bit(0x03,TFT_DATA); 
	TFT_Write_8bit(0x13,TFT_DATA); 
	TFT_Write_8bit(0xE1,TFT_CMD);       // дָ,ѹ
	TFT_Write_8bit(0x04,TFT_DATA); 
	TFT_Write_8bit(0x16,TFT_DATA); 
	TFT_Write_8bit(0x06,TFT_DATA); 
	TFT_Write_8bit(0x0D,TFT_DATA); 
	TFT_Write_8bit(0x2D,TFT_DATA); 
	TFT_Write_8bit(0x26,TFT_DATA); 
	TFT_Write_8bit(0x23,TFT_DATA); 
	TFT_Write_8bit(0x27,TFT_DATA); 
	TFT_Write_8bit(0x27,TFT_DATA); 
	TFT_Write_8bit(0x25,TFT_DATA); 
	TFT_Write_8bit(0x2D,TFT_DATA); 
	TFT_Write_8bit(0x3B,TFT_DATA); 
	TFT_Write_8bit(0x00,TFT_DATA); 
	TFT_Write_8bit(0x01,TFT_DATA); 
	TFT_Write_8bit(0x04,TFT_DATA); 
	TFT_Write_8bit(0x13,TFT_DATA); 
	//------------------------------------End ST7735S Gamma Sequence-----------------------------// 
	TFT_Write_8bit(0x3A,TFT_CMD); //65k mode 
	TFT_Write_8bit(0x05,TFT_DATA); 
	TFT_Write_8bit(0x29,TFT_CMD); //Display on 
}

/**
 * @name TFT_Fill
 * @brief ָɫ
 * @param x1,x2 еʼͽַ
 * @param y1,y2 еʼͽַ
 * @param color Ҫɫ
 * @return 
 * @version 汾v1.0
 * @date ڣ2024-5-13
 * @author ߣ
 * @note עͣ
 */
void TFT_Fill(u16 x1, u16 y1, u16 x2, u16 y2, u16 color)
{
    u16 i, j;
    u16 width = x2 - x1 + 1;        // õĿ
    u16 height = y2 - y1 + 1;       // ߶
    TFT_Windows_Set(x1, y1, x2, y2); // ʾ
    for (i = 0; i < height; i++)
    {
        for (j = 0; j < width; j++)
            TFT_Write_16bit(color); // д
    }
    TFT_Windows_Set(0, 0, TFT_X - 1, TFT_Y - 1); // ָΪȫ
}

void TFT_Clear(u16 color)
{
    TFT_Fill(0, 0, TFT_X - 1, TFT_Y - 1, color);
}



void TFT_DrawPoint(u16 x, u16 y, u16 color)
{
    TFT_Set_Cursor(x, y);
    TFT_Write_16bit(color);
}

void TFT_DrawLine(u16 x1, u16 y1, u16 x2, u16 y2, u16 color)
{
    u16 t;
    int xerr = 0, yerr = 0, delta_x, delta_y, distance;
    int incx, incy, uRow, uCol;
    delta_x = x2 - x1;      // 
    delta_y = y2 - y1;
    uRow = x1;              // 
    uCol = y1;
    if(delta_x > 0)
        incx = 1;           // õ
    else if (delta_x == 0)
        incx = 0;           // ֱ
    else
    {
        incx = -1;
        delta_x = -delta_x;
    }
    if(delta_y > 0)
        incy = 1;           // õ
    else if (delta_y == 0)
        incy = 0;           // ˮƽ
    else
    {
        incy = -1;
        delta_y = -delta_y;
    }
    if(delta_x > delta_y)
        distance = delta_x; // ѡȡ
    else
        distance = delta_y;
    for (t = 0; t < distance + 2; t++)
    {
        TFT_DrawPoint(uRow, uCol, color); // 
        xerr += delta_x;
        yerr += delta_y;
        if(xerr > distance)
		{
            xerr -= distance;
            uRow += incx;
        }
		if(yerr > distance)
		{
            yerr -= distance;
            uCol += incy;
        }
	}
}

// void TFT_DrawLine_Dot(u16 x1, u16 y1, u16 x2, u16 y2, u16 color, u8 dot)
// {
//     //ȼyͦx
//     u8 DeltaX = abs(x2 - x1);
//     u8 DeltaY = abs(y2 - y1);
//     u8 dm, i;           //ָ׼ѭ
//     float dx, dy;       //仯
//     float x, y;         //Ҫʾֵ

//     if(DeltaX >= DeltaY)  //ѡϳıΪ׼
//         dm = DeltaX;
//     else
//         dm = DeltaY;

//     dx = (float)(x2 - x1) / dm;
//     dy = (float)(y2 - y1) / dm;
//     x = (float)x1 + 0.5;    //
//     y = (float)y1 + 0.5;    //
//     for ( i = 0; i <= dm; i++)
//     {
//         if(!(i%dot) || i==1)
//             TFT_DrawPoint(x, y, color);
//         x += dx;
//         y += dy;
//     }
// }

void TFT_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2, u16 color)
{
    TFT_DrawLine(x1, y1, x2, y1, color);
    TFT_DrawLine(x1, y1, x1, y2, color);
    TFT_DrawLine(x1, y2, x2, y2, color);
    TFT_DrawLine(x2, y1, x2, y2, color);
}

void TFT_DrawRectangle_Fill(u16 x1, u16 y1, u16 x2, u16 y2, u16 color)
{
    TFT_Fill(x1, y1, x2, y2, color);
}


void TFT_DrawCircle_base(int x, int y, int Rx, int Ry, u16 color)
{
    TFT_DrawPoint(x + Rx, y + Ry, color);
    TFT_DrawPoint(x - Rx, y + Ry, color);
	TFT_DrawPoint(x + Rx, y - Ry, color);
	TFT_DrawPoint(x - Rx, y - Ry, color);
	TFT_DrawPoint(x + Ry, y + Rx, color);
	TFT_DrawPoint(x - Ry, y + Rx, color);
	TFT_DrawPoint(x + Ry, y - Rx, color);
	TFT_DrawPoint(x - Ry, y - Rx, color);
}

/**
 * @name TFT_DrwaCircle
 * @brief Բ
 * @param x0,y0 Բ
 * @param R 뾶
 * @return 
 * @version 汾v1.0
 * @date ڣ2024
 * @author ߣ
 * @note עͣ
 */
void TFT_DrwaCircle(int x0, int y0, int R, u16 color, bit fill)
{
    int x = 0, y = R, yi, d;
	d = 3 - 2 * R;
	if (fill)
	{
		// 䣨ʵԲ
		while (x <= y) 
        {
			for (yi = x; yi <= y; yi++)
				TFT_DrawCircle_base(x0, y0, x, yi, color);

			if (d < 0)
				d = d + 4 * x + 6;
			else 
            {
				d = d + 4 * (x - y) + 10;
				y--;
			}
			x++;
		}
	}
    else 
	{
		// 䣨Բ
		while (x <= y) 
        {
			TFT_DrawCircle_base(x0, y0, x, y, color);
			if (d < 0)
				d = d + 4 * x + 6;
			else
            {
				d = d + 4 * (x - y) + 10;
				y--;
			}
			x++;
		}
	}
}

static void _swap(u16 *a, u16 *b)
{
	u16 tmp;
    tmp = *a;
	*a = *b;
	*b = tmp;
}

void TFT_DrawTriangel(u16 x0, u16 y0, u16 x1, u16 y1, u16 x2, u16 y2, u16 color)
{
    TFT_DrawLine(x0, y0, x1, y1, color);
    TFT_DrawLine(x1, y1, x2, y2, color);
    TFT_DrawLine(x2, y2, x0, y0, color);
}

void TFT_DrawTriangel_Fill(u16 x0, u16 y0, u16 x1, u16 y1, u16 x2, u16 y2, u16 color)
{
    u16 a, b, y, last;
    int dx01, dy01, dx02, dy02, dx12, dy12;
    long sa = 0;
    long sb = 0;
    if (y0 > y1) 
	{
        _swap(&y0, &y1);
        _swap(&x0, &x1);
    }
    if (y1 > y2) 
	{
        _swap(&y2, &y1);
        _swap(&x2, &x1);
    }
    if (y0 > y1) 
	{
        _swap(&y0, &y1);
        _swap(&x0, &x1);
    }
	if(y0 == y2) 
	{
        a = b = x0;
        if(x1 < a)
            a = x1;
        else if(x1 > b)
			b = x1;
        if(x2 < a)
			a = x2;
		else if(x2 > b)
			b = x2;
        TFT_Fill(a, y0, b, y0, color);
        return;
    }

    dx01 = x1 - x0;
    dy01 = y1 - y0;
	dx02 = x2 - x0;
	dy02 = y2 - y0;
	dx12 = x2 - x1;
	dy12 = y2 - y1;
	
	if(y1 == y2)
        last = y1;
    else
        last = y1 - 1;
    for (y = y0; y <= last; y++)
    {
		a = x0 + sa / dy01;
		b = x0 + sb / dy02;
		sa += dx01;
        sb += dx02;
        if(a > b)
        {
            _swap(&a, &b);
        }
        TFT_Fill(a, y, b, y, color);
    }
    sa = dx12 * (y - y1);
	sb = dx02 * (y - y0);
	for (; y <= y2; y++)
    {
		a = x1 + sa / dy12;
		b = x0 + sb / dy02;
		sa += dx12;
		sb += dx02;
		if(a > b)
			_swap(&a,&b);
		TFT_Fill(a,y,b,y,color);
	}
}

/**
 * @name TFT_ShowChar
 * @brief ʾַ
 * @param x,y ʾʼ
 * @param fc ɫ
 * @param bc ɫ
 * @param chr Ҫʾַ
 * @param size ֺţ12,16,24,32 Ĭ16
 * @param mode 0 ǵģʽ  1 ģʽ
 * @return null
 * @version 汾v1.0
 * @date ڣ2024-5-14
 * @author ߣ
 * @note עͣ
 */
void TFT_ShowChar(u16 x, u16 y, u16 fc, u16 bc, char chr, u8 sizey, u8 mode)
{
    u8 temp, sizex, t, m = 0;
    u16 i, TypefaceNum;         // һַռֽڴС
    u16 x0 = x;
    sizex = sizey / 2;
    TypefaceNum = (sizex / 8 + ((sizex % 8) ? 1 : 0)) * sizey;
    chr = chr - ' ';            // õƫƺֵ
    TFT_Windows_Set(x, y, x + sizex - 1, y + sizey - 1);
    for (i = 0; i < TypefaceNum; i++)
    { 
		if (sizey == 12)
            temp = ascii_1206[chr][i];      // 1206
        else if (sizey == 16)
            temp = ascii_1608[chr][i];      // 1608
        else if (sizey == 24)
            temp = ascii_2412[chr][i];      // 2412
        else if (sizey == 32)
            temp = ascii_3216[chr][i];      // 3216
        else
            temp = ascii_1608[chr][i];      // Ĭϵ1608
        for (t = 0; t < 8; t++)
        {
			if(!mode)//ǵģʽ
			{
                if (temp & (0x01 << t))
                    TFT_Write_16bit(fc);
                else
                    TFT_Write_16bit(bc);
                m++;
                if (m % sizex == 0)
                {
                    m = 0;
                    break;
				}
			}
			else//ģʽ
			{
                if (temp & (0x01 << t))
                    TFT_DrawPoint(x, y, fc); // һ
                x++;
                if ((x - x0) == sizex)
                {
                    x = x0;
                    y++;
                    break;
                }
			}
		}
	}   
    TFT_Windows_Set(0, 0, TFT_X - 1, TFT_Y - 1); // ָΪȫ
}


void TFT_ShowString(u16 x, u16 y, u16 fc, u16 bc, char *chr, u8 sizey, u8 mode)
{
    while ((*chr <= '~') && (*chr >= ' ')) // жǲǷǷַ!
    {
        if (x > (TFT_X - 1) || y > (TFT_Y - 1))
            return;
        TFT_ShowChar(x, y, fc, bc, *chr, sizey, mode);
        x += sizey / 2;
        chr++;
    }  
}

/**
 * @name TFT_pow
 * @brief m^n
 * @param m^n
 * @return result
 * @version 汾v1.0
 * @date ڣ2024-5-15
 * @author ߣϫ
 * @note עͣ
 */
u32 TFT_pow(u8 m, u8 n)
{
    u32 result = 1;
    while(n--)
        result *= m;
    return result;
}

/**
 * @name TFT_ShowNum_u32
 * @brief ʾһ
 * @param x,y 
 * @param fc ɫ
 * @param bc ɫ
 * @param num ֵ(0~4294967295)
 * @param len ֵλʾλЧ,max=10
 * @param size ֺţ12,16,24,32 Ĭ16
 * @param mode 0 ǵģʽ  1 ģʽ
 * @return 
 * @version 汾v1.0
 * @date ڣ2024-5-15
 * @author ߣ
 * @note עͣ
 */
void TFT_ShowNum_u32(u16 x, u16 y, u16 fc, u16 bc, u32 num, u8 len, u8 sizey, u8 mode)
{
    u8 t, temp;
    u8 enshow = 0;
    u8 sizex = sizey / 2;
    if (len > 10)
        len = 10;
    for (t = 0; t < len; t++)
    {
        temp = (num / TFT_pow(10, (u8)(len - t - 1))) % 10;
        if (enshow == 0 && t < (len - 1))
        {
            if (temp == 0)
            {
                TFT_ShowChar(x + t * sizex, y, fc, bc, '0', sizey, mode);
                continue;
            }
            else
                enshow = 1;
        }
        TFT_ShowChar(x + t * sizex, y, fc, bc, (u8)(temp + 48), sizey, mode);
    }
}

/**
 * @name TFT_ShowNum_u32
 * @brief ʾһ
 * @param x,y 
 * @param fc ɫ
 * @param bc ɫ
 * @param num ֵ
 * @param len ֵλʾλЧ,max=10
 * @param decimal Сλ,max=4
 * @param size ֺţ12,16,24,32 Ĭ16
 * @param mode 0 ǵģʽ  1 ģʽ
 * @return
 * @version 汾v1.0
 * @date ڣ2024-5-15
 * @author ߣ
 * @note עͣ
 */
void TFT_ShowNum_float(u16 x, u16 y, u16 fc, u16 bc, float num, u8 len, u8 decimal, u8 sizey, u8 mode)
{
    u8 t, temp, sizex;
    u32 num1;
    sizex = sizey / 2;
    num1 = num * TFT_pow(10, decimal);
    if (len > 10)
        len = 10;
    if (decimal > 4)
        decimal = 4;
    for (t = 0; t < len; t++)
    {
        temp = (num1 / TFT_pow(10, (u8)(len - t -1))) % 10;
        if (t == (len - decimal))
        {
            TFT_ShowChar(x + (len - decimal) * sizex, y, fc, bc, '.', sizey, mode);
            t++;
            len += 1;
        }
        TFT_ShowChar(x + t * sizex, y, fc, bc, (u8)(temp + 48), sizey, mode);
    }
}

void TFT_ShowChinese12x12(u16 x, u16 y, u16 fc, u16 bc, char *s, u8 sizey, u8 mode)
{
	u8 i, j, k, m = 0;
	u8 pGBK = 0;
	u8 SingleChinese[TFT_CHN_CHAR_WIDTH + 1] = {0};
	u16 pIndex;
	u16 x0 = x;
	u16 TypefaceNum; // һַռֽڴС
	TypefaceNum = (sizey / 8 + ((sizey % 8) ? 1 : 0)) * sizey;
	for (i = 0; s[i] != '\0'; i++)	// Ҫʾĺֿ
	{
		SingleChinese[pGBK] = s[i];		// ȡִݵ
		pGBK++;                                 // ƴ
		/*ȡﺺֳʱȡһĺ*/
		if (pGBK >= TFT_CHN_CHAR_WIDTH)
		{
			pGBK = 0;
			/*ģ⣬Ѱƥĺ*/
			/*ҵһ֣Ϊַʾδģⶨ壬ֹͣѰ*/
			for (pIndex = 0; strcmp(Font_GB12[pIndex].txt, "") != 0; pIndex++)
			{
				/*ҵƥĺ*/
				if (strcmp(Font_GB12[pIndex].txt, SingleChinese) == 0)
				break;	// ѭʱpIndexֵΪֵָ
			}

			/*ģָ12*12ͼʽʾ*/
			TFT_Windows_Set(x, y, x + sizey - 1, y + sizey - 1);
			for (k = 0; k < TypefaceNum; k++)
			{
				for (j = 0; j < 8; j++)
				{
					if (!mode) 	// ǵӷʽ
					{
						if (Font_GB12[pIndex].dat[k] & (0x01 << j))
							TFT_Write_16bit(fc);
						else
							TFT_Write_16bit(bc);
						m++;
						if (m % sizey == 0)
						{
							m=0;
							break;
						}
					}
					else		// ӷʽ
					{
						if (Font_GB12[pIndex].dat[k] & (0x01 << j))
							TFT_DrawPoint(x, y, fc); // һ
						x++;
						if ((x - x0) == sizey)
						{
							x = x0;
							y++;
							break;
						}
					}
				}
			}
		}
		continue;	// ҵӦֿ˳ֹظȡģӰ
	}
	TFT_Windows_Set(0, 0, TFT_X - 1, TFT_Y - 1); // ָΪȫ
}


void TFT_ShowChinese16x16(u16 x, u16 y, u16 fc, u16 bc, char *s, u8 sizey, u8 mode)
{
	u8 i, j, k, m = 0;
	u8 pGBK = 0;
	u16 pIndex;
	u8 SingleChinese[TFT_CHN_CHAR_WIDTH + 1] = {0};
	u16 x0 = x;
	u16 TypefaceNum; // һַռֽڴС
	TypefaceNum = (sizey / 8 + ((sizey % 8) ? 1 : 0)) * sizey;
	for (i = 0; s[i] != '\0'; i++)	// Ҫʾĺֿ
	{
		SingleChinese[pGBK] = s[i];		// ȡִݵ
		pGBK++;                                 // ƴ
		/*ȡﺺֳʱȡһĺ*/
		if (pGBK >= TFT_CHN_CHAR_WIDTH)
		{
			pGBK = 0;
			/*ģ⣬Ѱƥĺ*/
			/*ҵһ֣Ϊַʾδģⶨ壬ֹͣѰ*/
			for (pIndex = 0; strcmp(Font_GB16[pIndex].txt, "") != 0; pIndex++)
			{
				/*ҵƥĺ*/
				if (strcmp(Font_GB16[pIndex].txt, SingleChinese) == 0)
				break;	// ѭʱpIndexֵΪֵָ
			}

			/*ģָ16*16ͼʽʾ*/
			TFT_Windows_Set(x, y, x + sizey - 1, y + sizey - 1);
			for (k = 0; k < TypefaceNum; k++)
			{
				for (j = 0; j < 8; j++)
				{
					if (!mode) 	// ǵӷʽ
					{
						if (Font_GB16[pIndex].dat[k] & (0x01 << j))
							TFT_Write_16bit(fc);
						else
							TFT_Write_16bit(bc);
						m++;
						if (m % sizey == 0)
						{
							m=0;
							break;
						}
					}
					else		// ӷʽ
					{
						if (Font_GB16[pIndex].dat[k] & (0x01 << j))
							TFT_DrawPoint(x, y, fc); // һ
						x++;
						if ((x - x0) == sizey)
						{
							x = x0;
							y++;
							break;
						}
					}
				}
			}
		}
		continue;	// ҵӦֿ˳ֹظȡģӰ
	}
	TFT_Windows_Set(0, 0, TFT_X - 1, TFT_Y - 1); // ָΪȫ
}

void TFT_ShowChinese24x24(u16 x, u16 y, u16 fc, u16 bc, char *s, u8 sizey, u8 mode)
{
	u8 i, j, k, m = 0;
	u8 pGBK = 0;
	u16 pIndex;
	u8 SingleChinese[TFT_CHN_CHAR_WIDTH + 1] = {0};
	u16 x0 = x;
	u16 TypefaceNum; // һַռֽڴС
	TypefaceNum = (sizey / 8 + ((sizey % 8) ? 1 : 0)) * sizey;
	for (i = 0; s[i] != '\0'; i++)	// Ҫʾĺֿ
	{
		SingleChinese[pGBK] = s[i];		// ȡִݵ
		pGBK++;                                 // ƴ
		/*ȡﺺֳʱȡһĺ*/
		if (pGBK >= TFT_CHN_CHAR_WIDTH)
		{
			pGBK = 0;
			/*ģ⣬Ѱƥĺ*/
			/*ҵһ֣Ϊַʾδģⶨ壬ֹͣѰ*/
			for (pIndex = 0; strcmp(Font_GB24[pIndex].txt, "") != 0; pIndex++)
			{
				/*ҵƥĺ*/
				if (strcmp(Font_GB24[pIndex].txt, SingleChinese) == 0)
				break;	// ѭʱpIndexֵΪֵָ
			}

			/*ģָ24*24ͼʽʾ*/
			TFT_Windows_Set(x, y, x + sizey - 1, y + sizey - 1);
			for (k = 0; k < TypefaceNum; k++)
			{
				for (j = 0; j < 8; j++)
				{
					if (!mode) 	// ǵӷʽ
					{
						if (Font_GB24[pIndex].dat[k] & (0x01 << j))
							TFT_Write_16bit(fc);
						else
							TFT_Write_16bit(bc);
						m++;
						if (m % sizey == 0)
						{
							m=0;
							break;
						}
					}
					else		// ӷʽ
					{
						if (Font_GB24[pIndex].dat[k] & (0x01 << j))
							TFT_DrawPoint(x, y, fc); // һ
						x++;
						if ((x - x0) == sizey)
						{
							x = x0;
							y++;
							break;
						}
					}
				}
			}
		}
	continue;	// ҵӦֿ˳ֹظȡģӰ
	}
	TFT_Windows_Set(0, 0, TFT_X - 1, TFT_Y - 1); // ָΪȫ
}


void TFT_ShowChinese32x32(u16 x, u16 y, u16 fc, u16 bc, char *s, u8 sizey, u8 mode)
{
	u8 i, j, k, m = 0;
	u8 pGBK = 0;
	u16 pIndex;
	u8 SingleChinese[TFT_CHN_CHAR_WIDTH + 1] = {0};
	u16 x0 = x;
	u16 TypefaceNum; // һַռֽڴС
	/*жsizeyǷԱ8ԣҪһµ*/
	TypefaceNum = (sizey / 8 + ((sizey % 8) ? 1 : 0)) * sizey;
	for (i = 0; s[i] != '\0'; i++)	// Ҫʾĺֿ
	{
		SingleChinese[pGBK] = s[i];		// ȡִݵ
		pGBK++;                                 // ƴ
		/*ȡﺺֳʱȡһĺ*/
		if (pGBK >= TFT_CHN_CHAR_WIDTH)
		{
			pGBK = 0;
			/*ģ⣬Ѱƥĺ*/
			/*ҵһ֣Ϊַʾδģⶨ壬ֹͣѰ*/
			for (pIndex = 0; strcmp(Font_GB32[pIndex].txt, "") != 0; pIndex++)
			{
				/*ҵƥĺ*/
				if (strcmp(Font_GB32[pIndex].txt, SingleChinese) == 0)
				break;	// ѭʱpIndexֵΪֵָ
			}

			/*ģָ32*32ͼʽʾ*/
			TFT_Windows_Set(x, y, x + sizey - 1, y + sizey - 1);
			for (k = 0; k < TypefaceNum; k++)
			{
				for (j = 0; j < 8; j++)
				{
					if (!mode) 	// ǵӷʽ
					{
						if (Font_GB32[pIndex].dat[k] & (0x01 << j))
							TFT_Write_16bit(fc);
						else
							TFT_Write_16bit(bc);
						m++;
						if (m % sizey == 0)
						{
							m=0;
							break;
						}
					}
					else		// ӷʽ
					{
						if (Font_GB32[pIndex].dat[k] & (0x01 << j))
							TFT_DrawPoint(x, y, fc); // һ
						x++;
						if ((x - x0) == sizey)
						{
							x = x0;
							y++;
							break;
						}
					}
				}
			}
		}
	continue;	// ҵӦֿ˳ֹظȡģӰ
	}
	TFT_Windows_Set(0, 0, TFT_X - 1, TFT_Y - 1); // ָΪȫ
}

void TFT_ShowStr_CN_EN(u16 x, u16 y, u16 fc, u16 bc, char *str, u8 sizey, u8 mode)
{
	u8 pGBK = 0;
    u8 i, k = 0;
    u8 SingleChinese[TFT_CHN_CHAR_WIDTH + 1] = {0};
	u8 sizex = sizey / 2;
    u16 px = x;
    
    for (i = 0; str[i] != '\0'; i++)
    {
        if ( (str[i] <= '~') && (str[i] >= ' ') )
        {
			TFT_ShowChar(px, y, fc, bc, str[i], sizey, mode);
			px += sizex;
            // Զ
            if (px + sizex > TFT_X)
            {
                px = 0;
                y += sizey;
                if (y > TFT_Y)
                    y = 0;
            }
        }
        else
        {
            SingleChinese[pGBK] = str[i];           // ȡִݵ
            pGBK++;                                 // ƴ

            /*ȡﺺֳʱȡһĺ*/
            if (pGBK >= TFT_CHN_CHAR_WIDTH)
            {
				pGBK = 0;       // ƴι
			
				if(sizey == 12)
					TFT_ShowChinese12x12(px, y, fc, bc, SingleChinese, sizey, mode);
				else if(sizey == 16)
					TFT_ShowChinese16x16(px, y, fc, bc, SingleChinese, sizey, mode);
				else if(sizey == 24)
					TFT_ShowChinese24x24(px, y, fc, bc, SingleChinese, sizey, mode);
				else if(sizey == 32)
					TFT_ShowChinese32x32(px, y, fc, bc, SingleChinese, sizey, mode);
				else	// Ĭ16
					TFT_ShowChinese16x16(px, y, fc, bc, SingleChinese, sizey, mode);

				// Զ
				px += sizey;
				if ( px + sizey > TFT_X)     
				{
					px = 0;
					y += sizey;
					if (y > TFT_Y)
						y = 0;
				}
			}
        }
    }
}


void TFT_Printf(u16 x, u16 y, u16 fc, u16 bc, u8 sizey, u8 mode, char *format, ...)
{
	char String[256];						//ַ
	va_list arg;							//ɱб͵ıarg
	va_start(arg, format);					//formatʼղбarg
	vsprintf(String, format, arg);			//ʹvsprintfӡʽַͲбַ
	va_end(arg);							//arg
	TFT_ShowStr_CN_EN(x, y, fc, bc, String, sizey, mode);
}

/**
 * @name TFT_ShowBmp
 * @brief ʾһBMPͼƬ
 * @param x,y ͼƬʼ
 * @param X,Y ͼƬĳС
 * @param pic ͼƬȡģ
 * @return 
 * @version 汾v1.0
 * @date ڣ2024-5-19
 * @author ߣ
 * @note עͣ
			BMPȡģ ȡģѡ:16λ-565,ˮƽɨ,,,λǰ
 */
void TFT_ShowBmp(u16 x, u16 y, u16 length_X, u16 width_Y, const u8 pic[])
{
	u16 i, j;
	u32 k = 0;
	if (x + length_X > TFT_X || y + width_Y > TFT_Y)
		return;
	TFT_Windows_Set(x, y, x + length_X - 1, y + width_Y - 1);
	for ( i = 0; i < length_X; i++)
	{
		for ( j = 0; j < width_Y; j++)
		{
			TFT_Write_8bit(pic[k * 2], TFT_DATA);		// ݸλǰ
			TFT_Write_8bit(pic[k * 2 + 1], TFT_DATA);
			k++;
		}
	}
	
}

// void Gui_Drawbmp16(u16 x,u16 y,const unsigned char *p) //ʾ40*40 QQͼƬ
// {
//   	int i; 
// 	unsigned char picH,picL; 
// 	LCD_SetWindows(x,y,x+40-1,y+40-1);//
//     for(i=0;i<40*40;i++)
// 	{	
// 	 	picL=*(p+i*2);	//ݵλǰ
// 		picH=*(p+i*2+1);				
// 		LCD_WR_DATA_16Bit(picH<<8|picL);  						
// 	}	
// 	LCD_SetWindows(0,0,lcddev.width-1,lcddev.height-1);//ָʾΪȫ	

// }

/**
 * @name TFT_ShowCurve
 * @brief Ʋͼ
 * @param x,y   ʾΧ
 * @param x1,y1 ʾΧյ
 * @param buff  ֵֵԪ128+1,129Ԫڱֵ
 * @param vol   
 * @param a     yʾС
 * @param b     ,һΪ0
 * @return 
 * @version 汾v1.0
 * @date ڣ2024-5-22
 * @author ߣϫ
 * @note ע֧ͣС
 */
void TFT_ShowCurve(u16 x, u16 y, u16 x1, u16 y1, u16 *buff, u16 vol, u8 a ,u16 b)
{
    u8 Xtime;
	// u16 max = buff[128];

	TFT_DrawLine(x, y - 1, x1, y - 1, RGB565_RED);      // 
    TFT_DrawLine(x, y1 + 1, x1, y1 + 1, RGB565_RED);    // 

    for ( Xtime = x1; Xtime > 0; Xtime--)
    {
        buff[Xtime] = buff[Xtime - 1];
    }

    for ( Xtime = 0; Xtime < x1; Xtime++)
    {
        TFT_Fill(Xtime, y, Xtime + 1, y1, RGB565_BLACK);
        TFT_DrawLine(Xtime, y1 - buff[Xtime], Xtime + 1, y1 - buff[Xtime + 1], RGB565_YELLOW);
    }

    buff[0] = ((vol - b) >= ((y1 - y) * a)) ? (y1 - y) : (vol - b) / a;

    // buff[129] = (buff[128] > buff[0] * a) ? buff[128] : buff[0] * a;       // жֵ
	buff[128] = buff[128] >= vol ? buff[128] : vol;

	TFT_Printf(127 - 6 * 10, y - 1 - 12, BLUE, RGB565_BLACK, 12, 0, "Max=%d  ", buff[128]);   // ֵ
    TFT_Printf(0, y - 1 - 12, BLUE, RGB565_BLACK, 12, 0, "%d  ", (y1 - y) * a + b);   //  ȱʶ
    TFT_Printf(0, y1 + 1 + 1, BLUE, RGB565_BLACK, 12, 0, "%d  ", vol - b + b);          //  ʼֵʶ
}

void TFT_Display_Test(void)
{
	u8 i = 0;
	u8 n = 0, m = 0;
	//   //
	TFT_DrawLine(0, 0, 127, 159, RED);
	TFT_DrawLine(0, 159, 127, 0, BLUE);
	TFT_DrawLine(0, 0, 127, 0, GREEN);
	TFT_DrawLine(0, 10, 127, 10, GREEN);
	TFT_DrawLine(0, 20, 127, 20, GREEN);
	TFT_DrawLine(0, 30, 127, 30, GREEN);
	TFT_DrawLine(0, 40, 127, 40, GREEN);
	TFT_DrawLine(0, 0, 0, 159, GREEN);
	TFT_DrawLine(10, 0, 10, 159, GREEN);
	TFT_DrawLine(20, 0, 20, 159, GREEN);
	TFT_DrawLine(30, 0, 30, 159, GREEN);
	TFT_DrawLine(40, 0, 40, 159, GREEN);
	delay_ms(1000);
	TFT_Clear(WHITE);
   // //   //
	TFT_DrawRectangle(0, 0, 127, 159, WHITE);
	TFT_DrawRectangle(1, 1, 126, 158, GREEN);
	TFT_DrawRectangle(2, 2, 125, 157, RED);
	TFT_DrawRectangle(3, 3, 124, 156, YELLOW);
	TFT_DrawRectangle(4, 4, 123, 155, BLUE);
	TFT_DrawRectangle(5, 5, 122, 154, BLACK);
	delay_ms(1000);
	TFT_Clear(WHITE);
   // //  ʵľ //
	TFT_DrawRectangle_Fill(0, 0, 63, 79, RED);
	TFT_DrawRectangle_Fill(63, 0, 127, 79, GREEN);
	TFT_DrawRectangle_Fill(0, 80, 63, 159, BLUE);
	TFT_DrawRectangle_Fill(63, 80, 172, 159, YELLOW);
	delay_ms(1000);
	TFT_Clear(WHITE);
   // //  Բ //
	TFT_DrwaCircle(63, 79, 50, RED, 0);
	TFT_DrwaCircle(63, 79, 40, GREEN, 0);
	TFT_DrwaCircle(63, 79, 30, BLUE, 0);
	delay_ms(1000);
	TFT_Clear(WHITE);
   // //  ʵԲ //
	TFT_DrwaCircle(63, 79, 50, RED, 1);
	TFT_DrwaCircle(63, 79, 40, GREEN, 1);
	TFT_DrwaCircle(63, 79, 30, BLUE, 1);
	delay_ms(1000);
	TFT_Clear(WHITE);
   // //   //
	TFT_DrawTriangel(63, 0, 0, 79, 127, 79, RED);
	TFT_DrawTriangel(63, 80, 0, 159, 127, 159, GREEN);
	TFT_DrawTriangel(63, 0, 0, 159, 127, 159, BLUE);
	delay_ms(1000);
	TFT_Clear(WHITE);
   // //  ʵ //
	TFT_DrawTriangel_Fill(63, 0, 0, 159, 127, 159, BLUE);
	TFT_DrawTriangel_Fill(63, 0, 0, 79, 127, 79, RED);
	TFT_DrawTriangel_Fill(63, 80, 0, 159, 127, 159, GREEN);
	delay_ms(1000);
	TFT_Clear(WHITE);
   //  дһַ //
	TFT_ShowChar(16*0, 32*0, RED, GREEN, 'T', 32, 0);
	TFT_ShowChar(16*1, 32*0, RED, GREEN, 'F', 32, 0);
	TFT_ShowChar(16*2, 32*0, RED, GREEN, 'T', 32, 0);
	TFT_ShowChar(16*0, 32*1, RED, GREEN, 'A', 32, 0);
	TFT_ShowChar(16*1, 32*1, RED, GREEN, 'S', 32, 0);
	TFT_ShowChar(16*2, 32*1, RED, GREEN, 'C', 32, 0);
	TFT_ShowChar(16*3, 32*1, RED, GREEN, 'I', 32, 0);
	TFT_ShowChar(16*4, 32*1, RED, GREEN, 'I', 32, 0);
	TFT_ShowChar(0, 32*2, RED, GREEN, '1', 32, 0);
	TFT_ShowChar(16, 32*2, RED, GREEN, '2', 24, 0);
	TFT_ShowChar(16+12, 32*2, RED, GREEN, '3', 16, 0);
	TFT_ShowChar(16+12+8, 32*2, RED, GREEN, '4', 12, 0);
	delay_ms(1000);
	TFT_Clear(WHITE);

    //  дһַ //
	TFT_ShowString(0, 0, RED, BLUE, "TFT", 32, 0);
	TFT_ShowString(0, 32, RED, GREEN, "ASCII", 32, 0);
	TFT_ShowString(0, 32+32, RED, YELLOW, "TEST!!", 24, 0);
	TFT_ShowString(0, 32+32+24, RED, YELLOW, "TEST!!", 16, 0);
	TFT_ShowString(0, 32+32+24+16, RED, YELLOW, "TEST!!", 12, 0);
	delay_ms(1000);
	TFT_Clear(WHITE);

    //  дu32 //
	TFT_ShowNum_u32(0, 0, RED, BLUE, 4294967295, 8, 32, 0);
	TFT_ShowNum_u32(0, 32, WHITE, BLACK, 4294967295, 10, 24, 0);
	TFT_ShowNum_u32(0, 32+24, YELLOW, GREEN, 4294967295, 16, 16, 0);
	TFT_ShowNum_u32(0, 32+24+16, BLUE, YELLOW, 4294967295, 21, 12, 0);
	delay_ms(1000);
	TFT_Clear(WHITE);

    //  дfloat //
    TFT_ShowNum_float(0, 0, RED, BLUE, 123.1234, 7, 4, 32, 0);
	TFT_ShowNum_float(0, 32, WHITE, BLACK, 123.1234, 7, 4, 24, 0);
	TFT_ShowNum_float(0, 32+24, YELLOW, GREEN, 123.1234, 10, 4, 16, 0);
	TFT_ShowNum_float(0, 32+24+16, BLUE, YELLOW, 0.9999, 10, 4, 12, 0);
	delay_ms(1000);
	TFT_Clear(WHITE);

    //  д //
    TFT_ShowChinese12x12(12*0, 0, RED, BLUE, "", 12, 0);
    TFT_ShowChinese12x12(12*1, 0, RED, BLUE, "", 12, 0);
    TFT_ShowChinese12x12(12*2, 0, RED, BLUE, "", 12, 0);
    TFT_ShowChinese12x12(12*3, 0, RED, BLUE, "", 12, 0);
    TFT_ShowChinese12x12(12*4, 0, RED, BLUE, "", 12, 0);

    TFT_ShowChinese16x16(16*0, 12, RED, GREEN, "", 16, 0);
    TFT_ShowChinese16x16(16*1, 12, RED, GREEN, "", 16, 0);
    TFT_ShowChinese16x16(16*2, 12, RED, GREEN, "", 16, 0);
    TFT_ShowChinese16x16(16*3, 12, RED, GREEN, "", 16, 0);
    TFT_ShowChinese16x16(16*4, 12, RED, GREEN, "", 16, 0);

    TFT_ShowChinese24x24(24*0, 12+16, RED, YELLOW, "", 24, 0);
    TFT_ShowChinese24x24(24*1, 12+16, RED, YELLOW, "", 24, 0);
    TFT_ShowChinese24x24(24*2, 12+16, RED, YELLOW, "", 24, 0);
    TFT_ShowChinese24x24(24*3, 12+16, RED, YELLOW, "", 24, 0);
    TFT_ShowChinese24x24(24*4, 12+16, RED, YELLOW, "", 24, 0);

    TFT_ShowChinese32x32(32*0, 12+16+24, RED, BLACK, "", 32, 0);
    TFT_ShowChinese32x32(32*1, 12+16+24, RED, BLACK, "", 32, 0);
    TFT_ShowChinese32x32(32*2, 12+16+24, RED, BLACK, "", 32, 0);
    TFT_ShowChinese32x32(32*3, 12+16+24, RED, BLACK, "", 32, 0);

    delay_ms(1000);
    TFT_Clear(WHITE);

    //  дӢ //
    TFT_ShowStr_CN_EN(12 * 0, 0, RED, BLUE, "չ", 12, 0);
    TFT_ShowStr_CN_EN(16 * 0, 12, RED, GREEN, "չ", 16, 0);
    TFT_ShowStr_CN_EN(24 * 0, 12 + 16, RED, YELLOW, "չ", 24, 0);
    TFT_ShowStr_CN_EN(32 * 0, 12 + 16 + 24, RED, BLACK, "չ", 32, 0);

	delay_ms(1000);
    TFT_Clear(WHITE);

    TFT_ShowStr_CN_EN(12 * 0, 0, RED, BLUE, "(123abc!~&)", 12, 0);
    TFT_ShowStr_CN_EN(16 * 0, 0 + 12, RED, GREEN, "(123abc!~&)", 16, 0);
    TFT_ShowStr_CN_EN(24 * 0, 0 + 12 + 16, RED, YELLOW, "(123abc!~&)", 24, 0);
    TFT_ShowStr_CN_EN(32 * 0, 0 + 12 + 16 + 24, RED, BLACK, "123abc!", 32, 0);

    delay_ms(1000);
    TFT_Clear(WHITE);

	//  ʾͼƬ //
	TFT_ShowBmp(0, 0, 40, 40, gImage_qq_40x40);
    TFT_ShowBmp(40, 0, 40, 40, gImage_qq_40x40);
    TFT_ShowBmp(80, 0, 40, 40, gImage_qq_40x40);

    TFT_ShowBmp(0, 40, 40, 40, gImage_qq_40x40);
    TFT_ShowBmp(40, 40, 40, 40, gImage_qq_40x40);
    TFT_ShowBmp(80, 40, 40, 40, gImage_qq_40x40);

    TFT_ShowBmp(0, 80, 40, 40, gImage_qq_40x40);
    TFT_ShowBmp(40, 80, 40, 40, gImage_qq_40x40);
    TFT_ShowBmp(80, 80, 40, 40, gImage_qq_40x40);

    TFT_ShowBmp(0, 120, 40, 40, gImage_qq_40x40);
    TFT_ShowBmp(40, 120, 40, 40, gImage_qq_40x40);
    TFT_ShowBmp(80, 120, 40, 40, gImage_qq_40x40);

	delay_ms(1000);
    TFT_Clear(WHITE);

    //  TFT Printf //
    for ( i = 0; i < 100; i++)
	{
		TFT_Printf(12 * 0, 0, RED, BLUE, 12, 0, "123abcABC:%d", i);
        TFT_Printf(16 * 0, 12, RED, GREEN, 16, 0, "չ:%d", i);
        TFT_Printf(24 * 0, 12 + 16, RED, YELLOW, 24, 0, ":%d", i);
        TFT_Printf(32 * 0, 12 + 16 + 24, RED, BLACK, 32, 0, "չ:%d", i);
        TFT_Printf(0, 12 + 16 + 24 + 32 + 32, RED, BLUE, 16, 0, "TFT_Printf");
	}
    delay_ms(1000);
    TFT_Clear(WHITE);

    //  ɫ //
	// for ( n = 0; n < 0xff; n++)
	// {
	// 	for ( m = 0; m < 0x20; m++)
	// 	{
	// 		TFT_Fill(0, 0, 128, 160, (u16)(n << 8 | m));
	// 		TFT_Printf(0, 0, RED, (u16)(n << 8 | m), 32, 0, "0x%x", (u16)(n << 8 | m));
	// 		// delay_ms(20);
	// 	}
	// }
    // delay_ms(1000);
    // TFT_Clear(WHITE);
}



