#ifndef __TFT128160_H_
#define __TFT128160_H_


#include "config.h"
#include "spi.h"

//ֺ֧ٶл
#define USE_HORIZONTAL  	    2   // Һ˳ʱת     0:0ת,  1:90ת,   2:180ת,   3:270ת
// #define LCD_USE8BIT_MODEL       1 	// Ƿʹ8λģʽ  0:ʹ16λģʽ, 1:ʹ8λģʽ

//LCDĳߴ
#if USE_HORIZONTAL==0||USE_HORIZONTAL==2    // 
#define TFT_X 128
#define TFT_Y 160

#else       // 
#define TFT_X 160
#define TFT_Y 128
#endif

// 궨RGB565ɫ
#define RGB565_BLACK          (uint16_t)(0x0000)  // ɫ
#define RGB565_WHITE          (uint16_t)(0xFFFF)  // ɫ
#define RGB565_RED            (uint16_t)(0xF800)  // ɫ
#define RGB565_GREEN          (uint16_t)(0x07E0)  // ɫ
#define RGB565_BLUE           (uint16_t)(0x001F)  // ɫ
#define RGB565_YELLOW         (uint16_t)(0xFFE0)  // ɫ
#define RGB565_CYAN           (uint16_t)(0x07FF)  // ɫ
#define RGB565_MAGENTA        (uint16_t)(0xF81F)  // Ʒɫ
#define RGB565_GREY           (uint16_t)(0x8410)  // ɫ
#define RGB565_NAVY           (uint16_t)(0x000F)  // 
#define RGB565_TEAL           (uint16_t)(0x0410)  // ɫ
#define RGB565_PURPLE         (uint16_t)(0x8010)  // ɫ
#define RGB565_OLIVE          (uint16_t)(0x8400)  // 
#define RGB565_LIME           (uint16_t)(0x07E0)  // ɫ

//ɫ
#define RED           	 0xF800     //
#define BRED             0XF81F     // #ɫ
#define BRRED 			 0XFC07     //غɫ #ɫ
#define MAGENTA       	 0xF81F     //Ʒɫɫ #ɫ

#define GREEN         	 0x07E0     //
#define LIGHTGREEN     	 0X841F     //ǳɫ

#define BLUE           	 0x001F     //
#define GBLUE			 0X07FF     //ɫ
#define CYAN          	 0x7FFF     //ɫɫ
#define LIGHTBLUE      	 0X7D7C	    //ǳɫ,GUIɫ
#define GRAYBLUE       	 0X5458     //ɫ,GUIɫ
#define DARKBLUE      	 0X01CF	    //ɫ,GUIɫ

#define YELLOW        	 0xFFE0     //ɫ
#define GRED 			 0XFFE0     //Ȼɫ

#define GRAY  			 0X8430     //ɫ
#define BROWN 			 0XBC40     //ɫ
#define WHITE         	 0xFFFF     //
#define BLACK         	 0x0000	    //

#define LGRAY 			 0XC618     //ǳɫ(PANNEL),屳ɫ
#define LGRAYBLUE        0XA651     //ǳɫ(мɫ)
#define LBBLUE           0X2B12     //ǳɫ(ѡĿķɫ)

#define TFT_CMD  0	//д
#define TFT_DATA 1	//д

//------------------------------Ŷ------------------------------

#define TFT18_BLK     P04             // Ļ
#define TFT18_RES     P20             // λź
#define TFT18_DC      P21             // /ź
#define TFT18_CS      P22             // Ƭѡź

//------------------------------------------------------------


//------------------------------------------------------------

void TFT_Write_8bit(u8 dat, u8 cmd);
void TFT_Write_16bit(u16 dat);
void TFT_Windows_Set(u16 x1, u16 y1, u16 x2, u16 y2);
void TFT_Set_Cursor(u16 x0, u16 y0);
void TFT_Init();

void TFT_Fill(u16 x1, u16 y1, u16 x2, u16 y2, u16 color);
void TFT_Clear(u16 color);
void TFT_DrawLine(u16 x1, u16 y1, u16 x2, u16 y2, u16 color);
// void TFT_DrawLine_Dot(u16 x1, u16 y1, u16 x2, u16 y2, u16 color, u8 dot);
void TFT_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2, u16 color);
void TFT_DrawRectangle_Fill(u16 x1, u16 y1, u16 x2, u16 y2, u16 color);
void TFT_DrawCircle_base(int x, int y, int Rx, int Ry, u16 color);
void TFT_DrwaCircle(int x0, int y0, int R, u16 color, bit fill);
void _swap(u16 *a, u16 *b);
void TFT_DrawTriangel(u16 x0, u16 y0, u16 x1, u16 y1, u16 x2, u16 y2, u16 color);
void TFT_DrawTriangel_Fill(u16 x0, u16 y0, u16 x1, u16 y1, u16 x2, u16 y2, u16 color);
void TFT_ShowChar(u16 x, u16 y, u16 fc, u16 bc, char chr, u8 size, u8 mode);
void TFT_ShowString(u16 x, u16 y, u16 fc, u16 bc, char *chr, u8 size, u8 mode);
void TFT_ShowNum_u32(u16 x, u16 y, u16 fc, u16 bc, u32 num, u8 len, u8 sizey, u8 mode);
void TFT_ShowNum_float(u16 x, u16 y, u16 fc, u16 bc, float num, u8 len, u8 decimal, u8 sizey, u8 mode);
void TFT_ShowChinese12x12(u16 x, u16 y, u16 fc, u16 bc, char *s, u8 sizey, u8 mode);
void TFT_ShowChinese16x16(u16 x, u16 y, u16 fc, u16 bc, char *s, u8 sizey, u8 mode);
void TFT_ShowChinese24x24(u16 x, u16 y, u16 fc, u16 bc, char *s, u8 sizey, u8 mode);
void TFT_ShowChinese32x32(u16 x, u16 y, u16 fc, u16 bc, char *s, u8 sizey, u8 mode);
void TFT_ShowStr_CN_EN(u16 x, u16 y, u16 fc, u16 bc, char *str, u8 sizey, u8 mode);
void TFT_Printf(u16 x, u16 y, u16 fc, u16 bc, u8 sizey, u8 mode, char *format, ...);
void TFT_ShowBmp(u16 x, u16 y, u16 length_X, u16 width_Y, const u8 pic[]);
void TFT_ShowCurve(u16 x, u16 y, u16 x1, u16 y1, u16 *buff, u16 vol, u8 a, u16 b);
void TFT_Display_Test(void);


//-----------------------------ṹ嶨------------------------------


#endif